:host {
  @apply(--paper-font-common-base);
  @apply(--paper-font-common-expensive-kerning);
  @apply(--paper-font-common-nowrap);
  color: var(--primary-text-color);
}

*:not(:defined) {
  &:after {
    content: 'unknown element';
    border: 1px solid #F00;
    padding: 5px;
    background: #F7EAEA;
  }
}

paper-button {
  --paper-button-ink-color: var(--primary-color);
  color: var(--primary-color);

  height: 2em;
  padding: 0.4em 0.57em;

  iron-icon {
    height: 100%;
    top: -1px;
  }
}

paper-icon-button {
  --paper-icon-button-ink-color: var(--primary-color);
  &[toggles] {
    &::before {
      border-radius: 2em;
    }
  }
}
paper-button, paper-icon-button {
  &[toggles] {
    &::before {
      content: "";
      transition: background-color 0.4s;
      width: 100%;
      height: 100%;
      position: absolute;
      top: 0;
      left: 0;
      opacity: .25;
      z-index: -1;
    }
    &[active]::before {
      background-color: var(--primary-color);
      &[secondary] {
        background-color: var(--accent-color);
      }
    }
    &[active] {
      &::before {
        background-color: var(--primary-color);
      }
      &[secondary]::before {
        background-color: var(--accent-color);
      }
      &[info]::before {
        background-color: var(--paper-blue-500);
      }
      &[warning]::before {
        background-color: var(--paper-orange-500);
      }
      &[error]::before {
        background-color: var(--error-color);
      }
    }
  }

  &[raised] {
    margin-bottom: 12px;
    &[primary] {
      color: var(--primary-text-color-inverted);
      background-color: var(--primary-color);
      --paper-button-ink-color: var(--primary-text-color-inverted);
    }
    &[secondary] {
      color: var(--primary-text-color);
      background-color: var(--accent-color);
      --paper-button-ink-color: var(--primary-text-color-inverted);
    }
    &[info] {
      color: var(--primary-text-color-inverted);
      background-color: var(--paper-blue-500);
      --paper-button-ink-color: var(--primary-text-color-inverted);
    }
    &[warning] {
      color: var(--primary-text-color-inverted);
      background-color: var(--paper-orange-500);
      --paper-button-ink-color: var(--primary-text-color-inverted);
    }
    &[error] {
      color: var(--primary-text-color-inverted);
      background-color: var(--error-color);
      --paper-button-ink-color: var(--primary-text-color-inverted);
    }
    &[disabled] {
      color: var(--primary-text-color-inverted);
      opacity: var(--disabled-text-opacity);
    }
  }

  &[primary] {
    color: var(--primary-color);
    --paper-button-ink-color: var(--primary-color);
    --paper-icon-button-ink-color: var(--paper-button-ink-color);
  }
  &[secondary] {
    color: var(--accent-color);
    --paper-button-ink-color: var(--accent-color);
    --paper-icon-button-ink-color: var(--paper-button-ink-color);
  }
  &[info] {
    color: var(--paper-blue-500);
    --paper-button-ink-color: var(--paper-blue-500);
    --paper-icon-button-ink-color: var(--paper-button-ink-color);
  }
  &[warning] {
    color: var(--paper-orange-500);
    --paper-button-ink-color: var(--paper-orange-500);
    --paper-icon-button-ink-color: var(--paper-button-ink-color);
  }
  &[error] {
    color: var(--error-color);
    --paper-button-ink-color: var(--error-color);
    --paper-icon-button-ink-color: var(--paper-button-ink-color);
  }
  &[disabled] {
    background-color: var(--paper-grey-300);
    opacity: var(--disabled-text-opacity);
  }
}

paper-card {
  .card-content {
    padding: 5px;
  }
}

$ink_size: 42px;
@mixin ink_padding($ink_size, $content_size) {
  padding: ($ink_size - $content_size)/2;
}
paper-checkbox {
  @include ink_padding($ink_size, 18px);
  --paper-checkbox-ink-size: 42px;
}
paper-radio-button {
  @include ink_padding($ink_size, 18px);
  --paper-radio-button-ink-size: 42px;
}
paper-toggle-button {
  @include ink_padding($ink_size, 18px);
}

paper-fab {
  --paper-fab-keyboard-focus-background: var(--light-accent-color);
  margin: 1em;
  transition: var(--shadow-transition_-_transition);

  &[primary] {
    --paper-fab-background: var(--primary-color);
    --paper-fab-keyboard-focus-background: var(--light-primary-color);
  }
  &[info] {
    --paper-fab-background: var(--paper-blue-500);
    --paper-fab-keyboard-focus-background: var(--paper-blue-200);
  }
  &[warning] {
    --paper-fab-background: var(--paper-orange-500);
    --paper-fab-keyboard-focus-background: var(--paper-orange-200);
  }
  &[error] {
    --paper-fab-background: var(--paper-red-500);
    --paper-fab-keyboard-focus-background: var(--paper-red-200);
  }
}

paper-tooltip {
  --paper-tooltip_-_font-size: .8rem;
  --paper-tooltip: #{"{
    font-size: .8rem;
  }"}
}

paper-material {
  background-color: var(--primary-background-color);
}

paper-slider {
  --paper-slider-active-color: var(--primary-color);
  --paper-slider-secondary-color: var(--accent-color);
  --paper-slider-knob-color: var(--dark-primary-color);
  --paper-slider-pin-color: var(--primary-color);
  --paper-slider-font-color: var(--primary-text-color);
}

paper-tabs {
  background-color: var(--primary-color);
  --paper-tabs-selection-bar-color: var(--accent-color);
}
paper-tab {
  --paper-tab-ink: var(--paper-tabs-selection-bar-color);
}

paper-item {
  --paper-item_-_min-height: 32px;
  --paper-item_-_padding: 0 16px;
  --paper-item_-_margin: 0;
}

dom-if, dom-repeat {
  margin-top: 0;
  padding: 0;
  height: 0;
}
